import { forEach } from '/@/utils/helper/treeHelper';
import { map } from 'xe-utils';
import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import {
  Tsk_LogListItem,
  Tsk_LogPageListGetResultModel,
  Tsk_LogPageParams,
} from '../model/tskModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useGlobSetting } from '/@/hooks/setting';

const globSetting = useGlobSetting();

/*
 * 获取任务日志分页列表
 */
export const getTsk_LogListByPage = async (params: Tsk_LogPageParams) => {
  let sqlcmd = '';
  if (params?.JobId != undefined && params?.JobId != '') {
    sqlcmd += " And JobId = '" + params?.JobId + "'";
  }
  if (params?.Status && params?.Status.length> 0) {
     params?.Status.forEach((item,index) => {
      if(index==0){
        sqlcmd+="and Status='"+item+"'"
      }else{
        sqlcmd+="Or Status='"+item+"'"
      }})
    //sqlcmd += " And Status = '" + params?.Status + "'";
  }
  if (params?.Description != undefined && params?.Description != '') {
    sqlcmd += " And Description = '" + params?.Description + "'";
  }
  if (params?.CREATE_TIME != undefined && params?.CREATE_TIME != '') {
    sqlcmd += "And CREATE_TIME > '" + params?.CREATE_TIME[0] + "'";
  }
  if (params?.CREATE_TIME != undefined && params?.CREATE_TIME != '') {
    sqlcmd += "And CREATE_TIME < '" + params?.CREATE_TIME[1] + "'";
  }
  const rParams = genActionPage('TSK_LOG', sqlcmd, params.page, params.pageSize);
  return getTsk_LogListByPageAsync(rParams);
};
async function getTsk_LogListByPageAsync(params: ApiActionPage) {
  const data = await defHttp.post<ApiActionPage>(
    { url: Api.EntityPageList, params },
    {
      isTransformResponse: false,
    },
  );
  data.Data.data.ElapsedTime=data.Data.data.ElapsedTime/1000;
  const model: Tsk_LogPageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  model.items.forEach(item=>{
    item.ElapsedTime = item.ElapsedTime / 1000
  })
  return model;
}

export const SaveTsk_Log = async (params: Tsk_LogListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('TSK_LOG', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
        apiUrl: globSetting.taskApiUrl
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('TSK_LOG', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
        apiUrl: globSetting.taskApiUrl
      },
    );
  }
  return data;
};

export const DeleteTsk_Log = async (params: Recordable) => {
  const usParams = genAction('TSK_LOG', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      apiUrl: globSetting.taskApiUrl
    },
  );
};
